{ **************************************************************************** }
{ *                                                                          * }
{ * LAS VEGAS (Bandai, LCD Game Digital) Simulator                           * }
{ * by Luca "MADrigal" Antignano, December 1999 (revision: August 2017)      * }
{ *                                                                          * }
{ * http://www.madrigaldesign.it/sim/                                        * }
{ * lucantignano@gmail.com                                                   * }
{ *                                                                          * }
{ * This source code (the "Software") is released as "open source" under the * }
{ * "Creative Common Attribution-NonCommercial-ShareAlike" license 4.0       * }
{ * available at:                                                            * }
{ * https://creativecommons.org/licenses/by-nc-sa/4.0/legalcode              * }
{ *                                                                          * }
{ * In addition to the constraints set by the CC license, you must respect   * }
{ * the following rules:                                                     * }
{ * a. do not offer the Software on a pay-per-play basis.                    * }
{ * b. do not distribute the Software through pre-paid access websites or    * }
{ *    BBS's.                                                                * }
{ * c. do not use the Software in publications of any form unless written    * }
{ *    consent is obtained by the author.                                    * }
{ * d. do not distribute the Software through mirror websites, unless        * }
{ *    written consent is obtained by the author.                            * }
{ * e. do not distribute older versions of the Software through authorized   * }
{ *    mirror websites after newer ones have been made available by the      * }
{ *    author.                                                               * }
{ *                                                                          * }
{ * Excerpt from the CC BY-NC-SA license 4.0                                 * }
{ * ========================================                                 * }
{ * BY: You must give appropriate credit, provide a link to the license, and * }
{ *     indicate if changes were made. You may do so in any reasonable       * }
{ *     manner, but not in any way that suggests the licensor endorses you   * }
{ *     or your use.                                                         * }
{ * NC: You may not use the material for commercial purposes.                * }
{ * SA: If you remix, transform, or build upon the material, you must        * }
{ *     distribute your contributions under the same license as the          * }
{ *     original.                                                            * }
{ *                                                                          * }
{ **************************************************************************** }

unit unit1;
{ this unit contains the main form implementation                              }

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, Math, Registry, Jpeg, Pngimage, Fmod, Fmodtypes, StdCtrls, Menus,
  ShellAPI;

type
  TForm1 = class(TForm)
{ * HANDHELD GRAPHICS, INCLUDING BUTTONS                                     * }

    // fullscreen mode items
    btn_game_menu_top:        TImage;
    btn_game_menu_background: TImage;

    im_backdrop:              TImage;
    im_backdrop_logo:         TImage;

    // electronic game
    im_background:            TImage;       im_background_screen_top: TImage;

    btn_sound_off:            TImage;       btn_sound_top:            TImage;
    btn_mode_down:            TImage;       btn_mode_top:             TImage;
    btn_acl_down:             TImage;       btn_acl_top:              TImage;

    btn_left_down:            TImage;       btn_left_top:             TImage;
    btn_right_down:           TImage;       btn_right_top:            TImage;

{ * LCD SCREEN GRAPHICS (SPRITES)                                            * }

    // on-screen panel (time/score, misses, game modes, etc.)
    im_panel_time: TImage; im_panel_game_1: TImage; im_panel_game_2: TImage;

    im_panel_digit_pos_1: TImage; im_panel_digit_pos_2: TImage; im_panel_digit_pos_3: TImage; im_panel_digit_pos_4: TImage; im_panel_digit_pos_5: TImage;
    im_panel_time_semicolon: TImage;
    im_panel_miss_1: TImage; im_panel_miss_2: TImage; im_panel_miss_3: TImage;

                                 im_panel_number_1_1: TImage;
    im_panel_number_2_0: TImage; im_panel_number_2_1: TImage; im_panel_number_2_2: TImage; im_panel_number_2_3: TImage; im_panel_number_2_4: TImage; im_panel_number_2_5: TImage; im_panel_number_2_6: TImage; im_panel_number_2_7: TImage; im_panel_number_2_8: TImage; im_panel_number_2_9: TImage;
    im_panel_number_3_0: TImage; im_panel_number_3_1: TImage; im_panel_number_3_2: TImage; im_panel_number_3_3: TImage; im_panel_number_3_4: TImage; im_panel_number_3_5: TImage; im_panel_number_3_6: TImage; im_panel_number_3_7: TImage; im_panel_number_3_8: TImage; im_panel_number_3_9: TImage;
    im_panel_number_4_0: TImage; im_panel_number_4_1: TImage; im_panel_number_4_2: TImage; im_panel_number_4_3: TImage; im_panel_number_4_4: TImage; im_panel_number_4_5: TImage; im_panel_number_4_6: TImage; im_panel_number_4_7: TImage; im_panel_number_4_8: TImage; im_panel_number_4_9: TImage;
    im_panel_number_5_0: TImage;

    // on-screen items
    im_hero_1: TImage; im_hero_2: TImage; im_hero_3: TImage;

    im_player_1a: TImage; im_player_2a: TImage; im_player_3a: TImage;
    im_player_1b: TImage; im_player_2b: TImage; im_player_3b: TImage;

    im_slot_1: TImage;    im_slot_2: TImage;    im_slot_3: TImage;

    im_coin_1_1: TImage;  im_coin_2_1: TImage;  im_coin_3_1: TImage;
    im_coin_1_2: TImage;  im_coin_2_2: TImage;  im_coin_3_2: TImage;
    im_coin_1_3: TImage;  im_coin_2_3: TImage;  im_coin_3_3: TImage;
    im_coin_1_4: TImage;  im_coin_2_4: TImage;  im_coin_3_4: TImage;

    im_slot_777_pos_1: TImage; im_slot_777_pos_2: TImage; im_slot_777_pos_3: TImage;
    im_slot_777_number_1: TImage; im_slot_777_number_3: TImage; im_slot_777_number_7: TImage;
    im_slot_777_hero_1: TImage; im_slot_777_hero_3: TImage; im_slot_777_hero_2: TImage;
    im_slot_777_bunny: TImage;
    im_slot_777_bag_1: TImage; im_slot_777_bag_2: TImage; im_slot_777_bag_3: TImage;

{ * TIMERS                                                                   * }
    Timer_Clock:           TTimer;

    Timer_Game_Start:      TTimer;
    Timer_Game_Over:       TTimer;

    Timer_Game:            TTimer;
    Timer_Game_Got:        TTimer;
    Timer_Game_Miss:       TTimer;

    Timer_Slot_777_Start:  TTimer;
    Timer_Slot_777_Action: TTimer;
    Timer_Slot_777_Spin:   TTimer;
    Timer_Slot_777_Bonus1: TTimer;
    Timer_Slot_777_Bonus2: TTimer;
    Timer_Slot_777_Bonus3: TTimer;
    Timer_Slot_777_Miss:   TTimer;

{ * POPUP MENU                                                               * }
    pm_0_menu:          TPopupMenu;
    pm_1_about:         TMenuItem;
    pm_2_readme:        TMenuItem;
    pm_3_whatsnew:      TMenuItem;
    pm_4_manual:        TMenuItem;
    pm_5_n1:            TMenuItem;
    pm_6_config:        TMenuItem;
    pm_7_keys:          TMenuItem;
    pm_8_hiscore:       TMenuItem;
    pm_9_n2:            TMenuItem;
  {}pm_10_fullscreen:   TMenuItem;
  {}pm_11_splashscreen: TMenuItem;
{}//pm_12_controller:   TMenuItem; (not required)
  {}pm_13_n3:           TMenuItem;
  {}pm_14_exit:         TMenuItem;

{ * PROCEDURES: INITIALIZE & SHUT DOWN                                       * }
    procedure FormCreate                    (Sender: TObject);
    procedure FormActivate                  (Sender: TObject);
    procedure FormClose                     (Sender: TObject; var Action: TCloseAction);

{ * PROCEDURES: DISPLAY MANAGEMENT                                           * }
    procedure Vid_Show_All                  (b: boolean);

    procedure Vid_Show_Hero_All             (b: boolean);
    procedure Vid_Show_Players_All          (b: boolean);
    procedure Vid_Show_Slots_All            (b: boolean);
    procedure Vid_Show_Coins_All            (b: boolean);
    procedure Vid_Show_Slot_777_Hero_All    (b: boolean);
    procedure Vid_Show_Slot_777_Bags_All    (b: boolean);

    procedure Vid_Show_Hero                 (var p: integer; b: boolean);
    procedure Vid_Show_Slot_777_Hero        (var p: integer);
    procedure Vid_Show_Slot_777_Bags        (var p: integer);

    procedure Vid_Show_Panel_Score          (var p: integer; b: boolean);
    procedure Vid_Show_Panel_Miss           (var p: integer);
    procedure Vid_Show_Slot_777_Score       (var p, q, r: integer; b: boolean);

{ * PROCEDURES: AUDIO MANAGEMENT                                             * }
    procedure Snd_Play                      (pfs: PFSoundSample);
    procedure Snd_Silence;

{ * PROCEDURES: INPUT MANAGEMENT - EVENTS                                    * }
    procedure im_backgroundMouseDown        (Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure im_backgroundMouseMove        (Sender: TObject;                       Shift: TShiftState; X, Y: Integer);

    procedure btn_sound_topMouseDown        (Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure btn_sound_topMouseUp          (Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure btn_mode_topMouseDown         (Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure btn_mode_topMouseUp           (Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure btn_acl_topMouseDown          (Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure btn_acl_topMouseUp            (Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);

    procedure btn_left_topMouseDown         (Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure btn_left_topMouseUp           (Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure btn_right_topMouseDown        (Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure btn_right_topMouseUp          (Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);

    procedure FormKeyDown                   (Sender: TObject; var Key: Word;        Shift: TShiftState);
    procedure FormKeyUp                     (Sender: TObject; var Key: Word;        Shift: TShiftState);

{ * PROCEDURES: INPUT MANAGEMENT - ACTIONS                                   * }
    procedure Inp_sound_down;               procedure Inp_sound_up;
    procedure Inp_mode_down;                procedure Inp_mode_up;
    procedure Inp_acl_down;                 procedure Inp_acl_up;

    procedure Inp_left_down;                procedure Inp_left_up;
    procedure Inp_right_down;               procedure Inp_right_up;

{ * PROCEDURES: GAME                                                         * }
    procedure Gam_Stop_Timers_All;

    procedure Gam_Clear_Coins_Array;
    procedure Gam_Set_Game_Difficulty;
    procedure Gam_Set_Mode;

{ * PROCEDURES: TIMERS                                                       * }
    procedure Timer_ClockTimer              (Sender: TObject);

    procedure Timer_Game_StartTimer         (Sender: TObject);
    procedure Timer_Game_OverTimer          (Sender: TObject);

    procedure Timer_GameTimer               (Sender: TObject);
    procedure Timer_Game_GotTimer           (Sender: TObject);
    procedure Timer_Game_MissTimer          (Sender: TObject);

    procedure Timer_Slot_777_StartTimer     (Sender: TObject);
    procedure Timer_Slot_777_ActionTimer    (Sender: TObject);
    procedure Timer_Slot_777_SpinTimer      (Sender: TObject);

    procedure Timer_Slot_777_Bonus1Timer    (Sender: TObject);
    procedure Timer_Slot_777_Bonus2Timer    (Sender: TObject);
    procedure Timer_Slot_777_Bonus3Timer    (Sender: TObject);

    procedure Timer_Slot_777_MissTimer      (Sender: TObject);

{ * PROCEDURES: POPUP MENU MANAGEMENT                                        * }
    procedure pm_0_menuPopup                (Sender: TObject);
    procedure pm_1_aboutClick               (Sender: TObject);
    procedure pm_2_readmeClick              (Sender: TObject);
    procedure pm_3_whatsnewClick            (Sender: TObject);
    procedure pm_4_manualClick              (Sender: TObject);
    procedure pm_6_configClick              (Sender: TObject);
    procedure pm_7_keysClick                (Sender: TObject);
    procedure pm_8_hiscoreClick             (Sender: TObject);
  {}procedure pm_10_fullscreenClick         (Sender: TObject);
  {}procedure pm_11_splashscreenClick       (Sender: TObject);
{}//procedure pm_12_controllerClick         (Sender: TObject);
  {}procedure pm_14_exitClick               (Sender: TObject);

{ * PROCEDURES: GAME MENU MANAGEMENT                                         * }
    procedure btn_game_menu_topClick        (Sender: TObject);

    procedure la_menu_itemMouseEnter        (Sender: TObject);
    procedure la_menu_itemMouseLeave        (Sender: TObject);
    procedure la_menu_itemMouseUp           (Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);

    procedure Vid_Display_Game_Menu         (b: boolean);
  end;

const
  APP_NAME       = 'Las Vegas (Bandai, LCD Game Digital) Simulator';            // application's name (appears on taskbar and Splash screen)
{}APP_VERSION    = 'Version 5.00 * Final *';                                    // current version (appears on Splash screen)
{}APP_DATE       = 'Released by Luca "MADrigal" Antignano on 4th December, 2017'; // release date (appears on Splash screen)

  URL_EMAIL      = 'mailto:lucantignano@gmail.com';                             // link to the email address
  URL_PAYPAL     = 'https://www.paypal.me/LucaAntignano';                       // link to the Paypal donation page
  URL_WEBSITE    = 'http://www.madrigaldesign.it/sim/';                         // link to the website

  REG_KEY        = 'Software\MADrigal\LasVegas50';                              // registry key

  HINT_CLICK     = 'click or press';
  HINT_MODE      = 'to select time and game modes';
  HINT_SOUND_OFF = 'to turn sound effects on';
  HINT_SOUND_ON  = 'to turn sound effects off';
  HINT_ACL       = 'to reset the game';

{}MENU_ITEMS = 13;
  NUM_KEYS = 5;

var
{ * main objects * }
  Form1:                   TForm1;                                              // main form
  bStartup:                boolean;                                             // manages splash screen at startup
  iMouseX, iMouseY:        integer;                                             // cursor coordinates (to drag main form)
  iReg:                    TRegIniFile;                                         // system registry (to save high-scores)

{ * sound management * }
  pfs_coin,
  pfs_gameover,
  pfs_got,
  pfs_miss,
  pfs_start:               PFSoundSample;                                       // sound samples

  bSound,                                                                       // sound enabled? (depending on selected driver on splash screen)
  bSoundGame:              boolean;                                             // sound enabled? (depending on selection at "Game A" or "Game B" startup)

{ * arrays of images * }
  aIm_Panel_Score:         array[1..5]       of TImage;                         // empty sprites containing score/time digits
  aIm_Panel_Numbers:       array[1..5, 0..9] of TImage;                         // digits for score/time display
  aIm_Panel_Misses:        array[1..3]       of TImage;                         // misses counter

  aIm_Hero:                array[1..3]       of TImage;                         // main character
  aIm_Players:             array[1..3, 1..2] of TImage;                         // slot machines players
  aIm_Slots:               array[1..3]       of TImage;                         // slot machines
  aIm_Coins:               array[1..3, 1..4] of TImage;                         // coins

  aIm_Slot_777_Score:      array[1..3]       of TImage;                         // empty sprites containing slot machine digits
  aIm_Slot_777_Numbers:    array[1..3]       of TImage;                         // digits for slot machine display
  aIm_Slot_777_Hero:       array[1..3]       of TImage;                         // main character (at the slot machine)
  aIm_Slot_777_Bags:       array[1..3]       of TImage;                         // money bags

{ * arrays of numbers *}
  aCoins:                  array[1..3, 1..4] of integer;                        // 0=empty; 1=lever down; 2=slot rolling; 3=coin on screen;
  aSlot777Number:          array[1..3]       of integer;                        // values: 1, 2 or 3 per cell
  aSlot777Seq:             array[1..5]       of integer;                        // values: 1, 2, 1, 2, 3

{ * arrays of mixed types * }
  aKeys:                   array[1..NUM_KEYS] of record                         // keys management (values)
                                                   int:  integer;
                                                   word: word;
                                                 end;

  aKeyHints:               array[1..44] of string;                              // keys management (hint on buttons)

  aMenuItem:               array[1..MENU_ITEMS] of TMenuItem;                   // popup menu items
  aMenuLabels:             array[1..MENU_ITEMS] of TLabel;                      // on-screen game menu labels

{ * integers and booleans * }
  iMode,                                                                        // 0=ACL, 1=time, 2=select G1, 3=select G2, 4=game G1, 5=game G2, 6=over G1, 7=over G2
  iScore,                                                                       // 0-9999
  iScoreNext,                                                                   // 1000, 2000, 3000, etc.
  iHiScore1,                                                                    // 0-9999
  iHiScore2,                                                                    // 0-9999
  iMisses,                                                                      // 0-5
  iHeroPos,                                                                     // 1-3
  iCoinsGenRnd,                                                                 // 6-20

  iSlot777ActiveDigit,                                                          // 0-3 (which digit is currently under control; 0=slot machine game has just started)
  iSlot777Bags                                                                  // 1-n (max 3 visible)
                         : integer;

{}bFullscreenMode,                                                              // true if video mode is fullscreen (false if "shaped game")
  bGameMenuOpen,                                                                // true if the on-screen menu is visible

  bSoundKeyPressed,                                                             // true while sound key is being kept pressed
  bModeKeyPressed,                                                              // true while time/mode key is being kept pressed
  bArrowKeyPressed,                                                             // true while left/right arrow keys are being kept pressed
  bControllersGame,                                                             // true while player plays the coin game
  bControllersSlot                                                              // true while player plays the slot machine game
                         : boolean;

  // Game variables: loops
  iLoopGameStart,                                                               // used in Timer_Game_Start               timer procedure
  iLoopGame,                                                                    // used in Timer_Game                     timer procedure
  iLoopGameActiveColumn,                                                        // used in Timer_Game                     timer procedure
  iLoopGameGot,                                                                 // used in Timer_Game_Got                 timer procedure
  iLoopGameMiss,                                                                // used in Timer_Game_Miss                timer procedure
  iLoopSlot777Start,                                                            // used in Timer_Slot_777_Start           timer procedure
  iLoopSlot777Action,                                                           // used in Timer_Slot_777_Action          timer procedure
  iLoopSlot777Spin,                                                             // used in Timer_Slot_777_Spin            timer procedure
  iLoopSlot777Bonus123,                                                         // used in Timer_Slot_777_Bonus1, 2 and 3 timer procedures
  iLoopSlot777Miss                                                              // used in Timer_Slot_777_Miss            timer procedure
                         : integer;

implementation

uses
  about, gfxinit, keys, manual, splash;

{$r *.dfm}










{ **************************************************************************** }
{ *                                                                          * }
{ * PROCEDURES: INITIALIZE & SHUT DOWN                                       * }
{ *                                                                          * }
{ **************************************************************************** }

procedure TForm1.FormCreate(Sender: TObject);
{ sprites on form are associated to arrays of images, needed to "index" them   }
{ variables are initialized: system registry, randomize, game mode, etc.       }
  var
    i: integer;
begin
  // initializes application name (for Windows taskbar)
  Application.Title := APP_NAME;

{}// sets game off the screen while graphics initialise
{}Top  := - Screen.Height;
{}Left := - Screen.Width;

  // on-screen panel (alarm, time/score, game a/b, etc.)
  aIm_Panel_Score[1] := im_panel_digit_pos_1; aIm_Panel_Score[2] := im_panel_digit_pos_2; aIm_Panel_Score[3] := im_panel_digit_pos_3; aIm_Panel_Score[4] := im_panel_digit_pos_4; aIm_Panel_Score[5] := im_panel_digit_pos_5;

                                                  aIm_Panel_Numbers[1, 1] := im_panel_number_1_1;
  aIm_Panel_Numbers[2, 0] := im_panel_number_2_0; aIm_Panel_Numbers[2, 1] := im_panel_number_2_1; aIm_Panel_Numbers[2, 2] := im_panel_number_2_2; aIm_Panel_Numbers[2, 3] := im_panel_number_2_3; aIm_Panel_Numbers[2, 4] := im_panel_number_2_4; aIm_Panel_Numbers[2, 5] := im_panel_number_2_5; aIm_Panel_Numbers[2, 6] := im_panel_number_2_6; aIm_Panel_Numbers[2, 7] := im_panel_number_2_7; aIm_Panel_Numbers[2, 8] := im_panel_number_2_8; aIm_Panel_Numbers[2, 9] := im_panel_number_2_9;
  aIm_Panel_Numbers[3, 0] := im_panel_number_3_0; aIm_Panel_Numbers[3, 1] := im_panel_number_3_1; aIm_Panel_Numbers[3, 2] := im_panel_number_3_2; aIm_Panel_Numbers[3, 3] := im_panel_number_3_3; aIm_Panel_Numbers[3, 4] := im_panel_number_3_4; aIm_Panel_Numbers[3, 5] := im_panel_number_3_5; aIm_Panel_Numbers[3, 6] := im_panel_number_3_6; aIm_Panel_Numbers[3, 7] := im_panel_number_3_7; aIm_Panel_Numbers[3, 8] := im_panel_number_3_8; aIm_Panel_Numbers[3, 9] := im_panel_number_3_9;
  aIm_Panel_Numbers[4, 0] := im_panel_number_4_0; aIm_Panel_Numbers[4, 1] := im_panel_number_4_1; aIm_Panel_Numbers[4, 2] := im_panel_number_4_2; aIm_Panel_Numbers[4, 3] := im_panel_number_4_3; aIm_Panel_Numbers[4, 4] := im_panel_number_4_4; aIm_Panel_Numbers[4, 5] := im_panel_number_4_5; aIm_Panel_Numbers[4, 6] := im_panel_number_4_6; aIm_Panel_Numbers[4, 7] := im_panel_number_4_7; aIm_Panel_Numbers[4, 8] := im_panel_number_4_8; aIm_Panel_Numbers[4, 9] := im_panel_number_4_9;
  aIm_Panel_Numbers[5, 0] := im_panel_number_5_0;

  aIm_Panel_Misses[1] := im_panel_miss_1; aIm_Panel_Misses[2] := im_panel_miss_2; aIm_Panel_Misses[3] := im_panel_miss_3;

  // on-screen items
  aIm_Hero[1] := im_hero_1; aIm_Hero[2] := im_hero_2; aIm_Hero[3] := im_hero_3;

  aIm_Players[1, 1] := im_player_1a; aIm_Players[2, 1] := im_player_2a; aIm_Players[3, 1] := im_player_3a;
  aIm_Players[1, 2] := im_player_1b; aIm_Players[2, 2] := im_player_2b; aIm_Players[3, 2] := im_player_3b;

  aIm_Slots[1] := im_slot_1; aIm_Slots[2] := im_slot_2; aIm_Slots[3] := im_slot_3;

  aIm_Coins[1, 1] := im_coin_1_1; aIm_Coins[2, 1] := im_coin_2_1; aIm_Coins[3, 1] := im_coin_3_1;
  aIm_Coins[1, 2] := im_coin_1_2; aIm_Coins[2, 2] := im_coin_2_2; aIm_Coins[3, 2] := im_coin_3_2;
  aIm_Coins[1, 3] := im_coin_1_3; aIm_Coins[2, 3] := im_coin_2_3; aIm_Coins[3, 3] := im_coin_3_3;
  aIm_Coins[1, 4] := im_coin_1_4; aIm_Coins[2, 4] := im_coin_2_4; aIm_Coins[3, 4] := im_coin_3_4;

  aIm_Slot_777_Score[1] := im_slot_777_pos_1; aIm_Slot_777_Score[2] := im_slot_777_pos_2; aIm_Slot_777_Score[3] := im_slot_777_pos_3;

  aIm_Slot_777_Numbers[1] := im_slot_777_number_1; aIm_Slot_777_Numbers[2] := im_slot_777_number_3; aIm_Slot_777_Numbers[3] := im_slot_777_number_7;

  aIm_Slot_777_Hero[1] := im_slot_777_hero_1; aIm_Slot_777_Hero[2] := im_slot_777_hero_2; aIm_Slot_777_Hero[3] := im_slot_777_hero_3;

  aIm_Slot_777_Bags[1] := im_slot_777_bag_1; aIm_Slot_777_Bags[2] := im_slot_777_bag_2; aIm_Slot_777_Bags[3] := im_slot_777_bag_3;

  // sets sequence of values for digits in the slot machine game
  aSlot777Seq[1] := 1; aSlot777Seq[2] := 2; aSlot777Seq[3] := 1; aSlot777Seq[4] := 2; aSlot777Seq[5] := 3;

  // registry keys management
  iReg := TregIniFile.Create(REG_KEY);                                          // system registry init

{}// init graphics
{}bFullscreenMode := iReg.ReadBool('', 'FullscreenMode', true);
{}pm_10_fullscreen.Checked := bFullscreenMode;
{}Gfxinit.Gfx_Game_Init;
{}bGameMenuOpen := false;

{}// initialises the "hints" array
  for i := 1 to 10 do
    aKeyHints[i] := '''' + Chr(i + 47) + '''';

  for i := 11 to 36 do
    aKeyHints[i] := '''' + Chr(i + 54) + '''';

  aKeyHints[37] := '''up arrow'' key';
  aKeyHints[38] := '''down arrow'' key';
  aKeyHints[39] := '''left arrow'' key';
  aKeyHints[40] := '''right arrow'' key';
  aKeyHints[41] := '''alt'' key';
  aKeyHints[42] := '''ctrl'' key';
  aKeyHints[43] := '''shift'' key';
  aKeyHints[44] := '''spacebar''';

  // reads values from system registry into the inputs array
  aKeys[1].int := iReg.ReadInteger('', 'Key1', 2);                              // "Mode"  (default: "1")
  aKeys[2].int := iReg.ReadInteger('', 'Key2', 3);                              // "Sound" (default: "2")
  aKeys[3].int := iReg.ReadInteger('', 'Key3', 6);                              // "ACL"   (default: "5")
  aKeys[4].int := iReg.ReadInteger('', 'Key4', 39);                             // "Left"  (default: "LEFT")
  aKeys[5].int := iReg.ReadInteger('', 'Key5', 40);                             // "Right" (default: "RIGHT")

  // writes values into the system registry (in case no pre-existing values
  // stored), then assigns key values to the key-inputs array
  for i := 1 to NUM_KEYS do
    begin
      iReg.WriteInteger('', 'Key' + inttostr(i), aKeys[i].int);
      KeysForm.AssignWord(i, aKeys[i].int);
    end;

  // sets button images hints
  btn_mode_top.Hint  := HINT_CLICK + ' ' + aKeyHints[aKeys[1].int] + ' ' + HINT_MODE;     // "Mode"
  btn_sound_top.Hint := HINT_CLICK + ' ' + aKeyHints[aKeys[2].int] + ' ' + HINT_SOUND_ON; // "Sound"
  btn_acl_top.Hint   := HINT_CLICK + ' ' + aKeyHints[aKeys[3].int] + ' ' + HINT_ACL;      // "ACL"
  btn_left_top.Hint  := HINT_CLICK + ' ' + aKeyHints[aKeys[4].int];                       // "Left"
  btn_right_top.Hint := HINT_CLICK + ' ' + aKeyHints[aKeys[5].int];                       // "Right"

  // popup menu array association
  aMenuItem[1]  := pm_1_about;
  aMenuItem[2]  := pm_2_readme;
  aMenuItem[3]  := pm_3_whatsnew;
  aMenuItem[4]  := pm_4_manual;
  aMenuItem[5]  := pm_5_n1;
  aMenuItem[6]  := pm_6_config;
  aMenuItem[7]  := pm_7_keys;
  aMenuItem[8]  := pm_8_hiscore;
  aMenuItem[9]  := pm_9_n2;
{}aMenuItem[10] := pm_10_fullscreen;
{}aMenuItem[11] := pm_11_splashscreen;
{}//               pm_12_controller;
{}aMenuItem[12] := pm_13_n3;
{}aMenuItem[13] := pm_14_exit;

  // variables init
  DoubleBuffered := true;                                                       // enables double buffering for rendering of "form1"

  iHiScore1 := iReg.ReadInteger('', 'HiScore1', iHiScore1);                     // reads value from system registry into iHiScore1
  iHiScore2 := iReg.ReadInteger('', 'HiScore2', iHiScore2);                     // reads value from system registry into iHiScore2

  bSoundGame := true;                                                           // enables ingame sound

  bSoundKeyPressed := false;                                                    // sound key is not currently being kept pressed
  bModeKeyPressed  := false;                                                    // mode key is not currently being kept pressed
  bArrowKeyPressed := false;                                                    // no arrow key is currently being kept pressed
  bControllersGame := false;                                                    // blocks main character movement
  bControllersSlot := false;                                                    // blocks main character movement

  Randomize;                                                                    // initializes the random number generator
end;





procedure TForm1.FormActivate(Sender: TObject);
{ sends focus to the splash screen at startup                                  }
begin
  if bStartup then
    begin
      bStartup := false;
      SplashForm.Show;
    end;
end;





procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
{ frees memory before shutting down                                            }
begin
  FSOUND_Sample_Free(pfs_coin);  FSOUND_Sample_Free(pfs_gameover);
  FSOUND_Sample_Free(pfs_got);   FSOUND_Sample_Free(pfs_miss);
  FSOUND_Sample_Free(pfs_start);

  FSOUND_Close;

{}iReg.Destroy;
  Action := caFree;
end;










{ **************************************************************************** }
{ *                                                                          * }
{ * PROCEDURES: DISPLAY MANAGEMENT                                           * }
{ *                                                                          * }
{ **************************************************************************** }

procedure TForm1.Vid_Show_All(b: boolean);
{ displays/hides all sprites                                                   }
  var
    i: integer;
begin
  im_panel_time.Visible := b; im_panel_time_semicolon.Visible := b;

  im_panel_game_1.Visible := b; im_panel_game_2.Visible := b;

  im_slot_777_bunny.Visible := b;

  Vid_Show_Hero_All(b);
  Vid_Show_Players_All(b);
  Vid_Show_Slots_All(b);
  Vid_Show_Coins_All(b);

  Vid_Show_Slot_777_Hero_All(b);
  Vid_Show_Slot_777_Bags_All(b);

  i := Round(Power(4, Ord(b))) - 1;                                             // same as if b then i := 3     else i := 0;
  Vid_Show_Panel_Miss(i);

  i := Round(Power(19991, Ord(b))) - 1;                                         // same as if b then i := 19990 else i := 0;
  Vid_Show_Panel_Score(i, b);

  i := 2; Vid_Show_Slot_777_Score(i, i, i, b);                                  // view slot machine as "333"
end;





procedure TForm1.Vid_Show_Hero_All(b: boolean);
{ displays/hides all main character sprites                                    }
  var
    i: integer;
begin
  for i := 1 to 3 do
    aIm_Hero[i].Visible := b;
end;





procedure TForm1.Vid_Show_Players_All(b: boolean);
{ displays/hides all slot machines players sprites                             }
  var
    i, j: integer;
begin
  for i := 1 to 3 do
    for j := 1 to 2 do
      aIm_Players[i, j].Visible := b;
end;





procedure TForm1.Vid_Show_Slots_All(b: boolean);
{ displays/hides all slot machines sprites                                     }
  var
    i: integer;
begin
  for i := 1 to 3 do
    aIm_Slots[i].Visible := b;
end;





procedure TForm1.Vid_Show_Coins_All(b: boolean);
{ displays/hides all coins                                                     }
  var
    i, j: integer;
begin
  for i := 1 to 3 do
    for j := 1 to 4 do
      aIm_Coins[i, j].Visible := b;
end;





procedure TForm1.Vid_Show_Slot_777_Hero_All(b: boolean);
{ displays/hides all main character sprites (at the slot machine)              }
  var
    i: integer;
begin
  for i := 1 to 3 do
    aIm_Slot_777_Hero[i].Visible := b;
end;





procedure TForm1.Vid_Show_Slot_777_Bags_All(b: boolean);
{ displays/hides all money bags sprites (at the slot machine)                  }
  var
    i: integer;
begin
  for i := 1 to 3 do
    aIm_Slot_777_Bags[i].Visible := b;
end;





procedure  TForm1.Vid_Show_Hero(var p: integer; b: boolean);
{ displays/hides main character sprite                                         }
begin
  aIm_Hero[p].Visible := b;
end;





procedure TForm1.Vid_Show_Slot_777_Hero(var p: integer);
{ displays hero in the slot machine game (0=nothing visible)                   }
begin
  case p of
    0: begin aIm_Slot_777_Hero[1].Visible := false; aIm_Slot_777_Hero[2].Visible := false; aIm_Slot_777_Hero[3].Visible := false; end;
    1: begin aIm_Slot_777_Hero[1].Visible := true;  aIm_Slot_777_Hero[2].Visible := true;  aIm_Slot_777_Hero[3].Visible := false; end;
    2: begin aIm_Slot_777_Hero[1].Visible := true;  aIm_Slot_777_Hero[2].Visible := false; aIm_Slot_777_Hero[3].Visible := true;  end;
  end; // case..of
end;





procedure TForm1.Vid_Show_Slot_777_Bags(var p: integer);
{ displays as many sprites as p on the bags counter (0=nothing visible)        }
  var
    i: integer;
begin
  for i := 1 to 3 do
    aIm_Slot_777_Bags[i].Visible := (i <= p);                                   // displays bags 1 to p, hides the remaining ones
end;





procedure TForm1.Vid_Show_Panel_Score(var p: integer; b: boolean);
{ transforms score/high-score into sprites, and displays/hides them            }
  var
    i, t: integer;
begin
  t := p;

  while t >= 20000 do                                                           // prevents score from being displayed in case it's greater than 19990
    Dec (t, 20000);

  for i := 1 to 5 do                                                            // displays or hides the panel sprites?
    aIm_Panel_Score[i].Visible := b;

  if b then                                                                     // displays or hide score/high-score?
    begin                                                                         // displays
      if t > 9999 then aIm_Panel_Score[1].Picture := aIm_Panel_Numbers[1, 1].Picture                   else aIm_Panel_Score[1].Picture := nil; // tens of thousands
                       aIm_Panel_Score[2].Picture := aIm_Panel_Numbers[2, t div  1000 mod 10].Picture;                                         // thousands
                       aIm_Panel_Score[3].Picture := aIm_Panel_Numbers[3, t div   100 mod 10].Picture;                                         // hundreds
                       aIm_Panel_Score[4].Picture := aIm_Panel_Numbers[4, t div    10 mod 10].Picture;                                         // tens
                       aIm_Panel_Score[5].Picture := aIm_Panel_Numbers[5, 0].Picture;                                                          // units
    end
  else                                                                            // hides
    for i := 1 to 5 do
      aIm_Panel_Score[i].Picture := nil;
end;





procedure TForm1.Vid_Show_Panel_Miss(var p: integer);
{ displays as many sprites as p on the misses counter (0=nothing visible)      }
  var
    i: integer;
begin
  for i := 1 to 3 do
    aIm_Panel_Misses[i].Visible := (i <= p);                                    // displays misses 1 to p, hides the remaining ones
end;





procedure TForm1.Vid_Show_Slot_777_Score(var p, q, r: integer; b: boolean);
{ transforms slot machine result into sprites, and displays/hides them         }
  var
    i: integer;
begin
  for i := 1 to 3 do                                                            // displays or hides the panel sprites?
    aIm_Slot_777_Score[i].Visible := b;

  aIm_Slot_777_Score[1].Picture := aIm_Slot_777_Numbers[p].Picture; // hundreds
  aIm_Slot_777_Score[2].Picture := aIm_Slot_777_Numbers[q].Picture; // tens
  aIm_Slot_777_Score[3].Picture := aIm_Slot_777_Numbers[r].Picture; // units
end;










{ **************************************************************************** }
{ *                                                                          * }
{ * PROCEDURES: AUDIO MANAGEMENT                                             * }
{ *                                                                          * }
{ **************************************************************************** }

procedure TForm1.Snd_Play(pfs: PFSoundSample);
{ plays a certain sound sample                                                 }
begin
  if bSound and bSoundGame then
    FSOUND_PlaySound(0, pfs);
end;





procedure TForm1.Snd_Silence;
{ stops any currently playing sound sample                                     }
begin
  if bSound and bSoundGame then
    FSOUND_StopSound(FSOUND_ALL);
end;










{ **************************************************************************** }
{ *                                                                          * }
{ * PROCEDURES: INPUT MANAGEMENT - EVENTS                                    * }
{ *                                                                          * }
{ **************************************************************************** }

procedure TForm1.im_backgroundMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
{ dragging the main form: PRESS                                                }
{ Note: this routine works if the game is not in 'Fullscreen' mode only        }
begin
{}if (not bFullscreenMode)
    and (Button = mbLeft) then
    begin
      iMouseX := X;
      iMouseY := Y;
    end;
end;





procedure TForm1.im_backgroundMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
{ dragging the main form: MOVE                                                 }
{ Note: this routine works if the game is not in 'Fullscreen' mode only        }
begin
{}if (not bFullscreenMode)
    and (ssLeft in Shift) then
    begin
      Top  := Top  + Y - iMouseY;
      Left := Left + X - iMouseX;
    end;
end;





procedure TForm1.btn_sound_topMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
{ sound button: PRESS                                                          }
begin
  if Button = mbLeft then
    Inp_sound_down;
end;





procedure TForm1.btn_sound_topMouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
{ sound button: RELEASE                                                        }
begin
  if Button = mbLeft then
    Inp_sound_up;
end;





procedure TForm1.btn_mode_topMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
{ mode button: PRESS                                                           }
begin
  if Button = mbLeft then
    Inp_mode_down;
end;





procedure TForm1.btn_mode_topMouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
{ mode button: RELEASE                                                         }
begin
  if Button = mbLeft then
    Inp_mode_up;
end;





procedure TForm1.btn_acl_topMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
{ ACL button: PRESS                                                            }
begin
  if Button = mbleft then
    Inp_acl_down;
end;





procedure TForm1.btn_acl_topMouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
{ ACL button: RELEASE                                                          }
begin
 if Button = mbLeft then
   Inp_acl_up;
end;





procedure TForm1.btn_left_topMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
{ left button: PRESS                                                           }
begin
  if Button = mbLeft then
    Inp_left_down;
end;





procedure TForm1.btn_left_topMouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
{ left button: RELEASE                                                         }
begin
  if Button = mbLeft then
    Inp_left_up;
end;





procedure TForm1.btn_right_topMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
{ right button: PRESS                                                          }
begin
  if Button = mbLeft then
    Inp_right_down;
end;





procedure TForm1.btn_right_topMouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
{ right button: RELEASE                                                        }
begin
  if Button = mbLeft then
    Inp_right_up;
end;





procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
{ keypress: PRESS                                                              }
begin
  // note: can't use the "case..of" construct on the aKeys[n].word
  if Key = aKeys[1].word then Inp_mode_down   else                              // Mode
  if Key = aKeys[2].word then Inp_sound_down  else                              // Sound
  if Key = aKeys[3].word then Inp_acl_down    else                              // ACL
  if Key = aKeys[4].word then Inp_left_down   else                              // left
  if Key = aKeys[5].word then Inp_right_down;                                   // right
end;





procedure TForm1.FormKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
{ keypresses: RELEASE                                                          }
begin
  // note: can't use the "case..of" construct on the aKeys[n].word
  if Key = aKeys[1].word then Inp_mode_up   else                                // Mode
  if Key = aKeys[2].word then Inp_sound_up  else                                // Sound
  if Key = aKeys[3].word then Inp_acl_up    else                                // ACL
  if Key = aKeys[4].word then Inp_left_up   else                                // left
  if Key = aKeys[5].word then Inp_right_up;                                     // right
end;










{ **************************************************************************** }
{ *                                                                          * }
{ * PROCEDURES: INPUT MANAGEMENT - ACTIONS                                   * }
{ *                                                                          * }
{ **************************************************************************** }

procedure TForm1.Inp_sound_down;
{ sound button: PRESS                                                          }
begin
  if not bSoundKeyPressed then
    begin
      bSoundKeyPressed := true;

      bSoundGame := not bSoundGame;                                             // enables/disables ingame sounds

      if bSoundGame then                                                        // if sound enabled
        btn_sound_top.Hint := HINT_CLICK + ' ' + aKeyHints[aKeys[2].int] + ' ' + HINT_SOUND_ON // sets hint over the "sound" button
      else                                                                      // else
        begin
          Snd_Silence;                                                            // stops any currently playing sound
          btn_sound_top.Hint := HINT_CLICK + ' ' + aKeyHints[aKeys[2].int] + ' ' + HINT_SOUND_OFF; // sets hint over the "sound" button
        end;

      btn_sound_off.Visible := not bSoundGame;                                  // displays button in "on" or "off" mode
    end;
end;





procedure TForm1.Inp_sound_up;
{ sound button: RELEASE                                                        }
begin
  bSoundKeyPressed := false;
end;





procedure TForm1.Inp_mode_down;
{ mode button: PRESS                                                           }
begin
  if not bModeKeyPressed then
    begin
      bModeKeyPressed := true;

      btn_mode_down.Visible := true;

      // switches between "time" and "game" modes
      if (iMode >=1) and (iMode <=7) and (iMode <> 4) and (iMode <> 5) then     // any mode except game G1 and game G2
        begin
          if (iMode = 1) or (iMode = 2) then                                      // 1 -> 2 or 2 -> 3
            Inc(iMode)
          else
            iMode := 1;                                                           // 3 -> 1 or 6 -> 1 or 7 -> 1

          Gam_Set_Mode;
        end;
    end;
end;





procedure TForm1.Inp_mode_up;
{ mode button: RELEASE                                                         }
begin
  btn_mode_down.Visible := false;
  bModeKeyPressed := false;
end;





procedure Tform1.Inp_acl_down;
{ ACL button: PRESS                                                            }
begin
  btn_acl_down.Visible := true;

  // game mode is set to "ACL"
  iMode := 0;
  Gam_Set_Mode;                                                                 
end;





procedure TForm1.Inp_acl_up;
{ ACL button: RELEASE                                                          }
begin
  btn_acl_down.Visible := false;

  // game mode is set to "time"
  iMode := 1;
  Gam_Set_Mode;                                                                 
end;





procedure TForm1.Inp_left_down;
{ left button: PRESS                                                           }
begin
  btn_left_down.Visible := true;

  if not bArrowKeyPressed then
    begin
      bArrowKeyPressed := true;

      // goes into "game" mode if in "select" mode
      if (iMode = 2) or (iMode = 3) then
        begin
          Inc(iMode, 2);
          Gam_Set_Mode;
        end;

      // coins game?
      if ((iMode = 4) or (iMode = 5))
      and bControllersGame
      and (iHeroPos > 1) then
        begin
          // moves hero left
          Vid_Show_Hero(iHeroPos, false);
          Dec(iHeroPos);
          Vid_Show_Hero(iHeroPos, true);

          // got a coin?
          if aCoins[iHeroPos, 3] = 3 then
            begin
              Gam_Stop_Timers_All;
              bControllersGame := false;

              iLoopGameGot := 1;
              Timer_Game_Got.Interval := 1;
              Timer_Game_Got.Enabled := true;
            end;
        end;
    end;
end;





procedure TForm1.Inp_left_up;
{ left button: RELEASE                                                         }
begin
  btn_left_down.Visible := false;
  bArrowKeyPressed := false;
end;





procedure TForm1.Inp_right_down;
{ right button: PRESS                                                          }
begin
  btn_right_down.Visible := true;

  if not bArrowKeyPressed then
    begin
      bArrowKeyPressed:=true;

      // goes into "game" mode if in "select" mode
      if (iMode = 2) or (iMode = 3) then
        begin
          Inc(iMode, 2);
          Gam_Set_Mode;
        end;

      // coins game?
      if ((iMode = 4) or (iMode = 5))
      and bControllersGame
      and (iHeroPos < 3) then
        begin
          // moves hero right
          Vid_Show_Hero(iHeroPos, false);
          Inc(iHeroPos);
          Vid_Show_Hero(iHeroPos, true);

          // got a coin?
          if aCoins[iHeroPos, 3] = 3 then
            begin
              Gam_Stop_Timers_All;
              bControllersGame := false;

              iLoopGameGot := 1;
              Timer_Game_Got.Interval := 1;
              Timer_Game_Got.Enabled := true;
            end;
        end;

      // slot machine game?
      if ((iMode = 4) or (iMode = 5))
      and bControllersSlot then
        begin
          iLoopSlot777Action := 1;
          Timer_Slot_777_Action.Interval := 1;
          Timer_Slot_777_Action.Enabled := true;
        end;
    end;
end;





procedure TForm1.Inp_right_up;
{ right button: RELEASE                                                        }
begin
  btn_right_down.Visible := false;
  bArrowKeyPressed := false;
end;










{ **************************************************************************** }
{ *                                                                          * }
{ * PROCEDURES: GAME ROUTINES                                                * }
{ *                                                                          * }
{ **************************************************************************** }

procedure TForm1.Gam_Stop_Timers_All;
{ stops all timers at once                                                     }
begin
  Timer_Clock.Enabled           := false;

  Timer_Game_Start.Enabled      := false;
  Timer_Game_Over.Enabled       := false;

  Timer_Game.Enabled            := false;
  Timer_Game_Got.Enabled        := false;
  Timer_Game_Miss.Enabled       := false;

  Timer_Slot_777_Start.Enabled  := false;
  Timer_Slot_777_Action.Enabled := false;
  Timer_Slot_777_Spin.Enabled   := false;

  Timer_Slot_777_Bonus1.Enabled := false;
  Timer_Slot_777_Bonus2.Enabled := false;
  Timer_Slot_777_Bonus3.Enabled := false;

  Timer_Slot_777_Miss.Enabled   := false;
end;





procedure TForm1.Gam_Clear_Coins_Array;
{ sets all cells of the aCoins array to zero                                   }
  var
    i, j: integer;
begin
  for i := 1 to 3 do
    for j := 1 to 4 do
      aCoins[i, j] := 0;
end;





procedure TForm1.Gam_Set_Game_Difficulty;
{ sets value of the Timer_Game interval, making game faster/slower depending   }
{ on which game is playing (G1 or G2) and current score. also sets value of    }
{ the iCoinsGenRnd variable, depending on current score                        }
  var
    i: integer;
begin
  i := (iScore div 1000) + 1;

  while i > 19 do
    Dec(i, 20);

  // game G1 speed
  case i of
    1: Timer_Game.interval := 220; // real
    2: Timer_Game.interval := 190; // real
    3: Timer_Game.interval := 180; // real
    4: Timer_Game.interval := 175; // real
    5: Timer_Game.interval := 170;
    6: Timer_Game.interval := 165;
    7: Timer_Game.interval := 163;
    8: Timer_Game.interval := 160;
    9: Timer_Game.interval := 158;
   10: Timer_Game.interval := 155;
   11: Timer_Game.interval := 153;
   12: Timer_Game.interval := 150;
   13: Timer_Game.interval := 148;
   14: Timer_Game.interval := 145;
   15: Timer_Game.interval := 143;
   16: Timer_Game.interval := 140;
   17: Timer_Game.interval := 138;
   18: Timer_Game.interval := 135;
   19: Timer_Game.interval := 133;
   20: Timer_Game.interval := 130;
  end; // case..of

  // for game G2: sets speed and makes iCoinsGenRnd value decrease more quickly
  if iMode = 5 then
    begin
      Timer_Game.Interval := Timer_Game.interval - 25; // real
      Inc(i, 2);
    end;

  // sets iCoinsGenRnd variable
  if i = 1 then iCoinsGenRnd := 18 else
  if i = 2 then iCoinsGenRnd := 15 else
  if i = 3 then iCoinsGenRnd := 13 else
  if i = 4 then iCoinsGenRnd := 11 else
  if i = 5 then iCoinsGenRnd :=  9 else
  if i = 6 then iCoinsGenRnd :=  8 else
  if i = 7 then iCoinsGenRnd :=  7 else
                iCoinsGenRnd :=  6;
end;





procedure TForm1.Gam_Set_Mode;
{ sets game/time/ACL/etc. mode, depending on the value of the iMode variable   }
begin
  case iMode of
    0: begin                                                                    // ACL
         Gam_Stop_Timers_All;                                                     // stops all timers
         Snd_Silence;                                                             // stops sound play
         Vid_Show_All(false);                                                     // hides all coins, chars, etc.
         bControllersGame := false;                                               // blocks main character movement
         bControllersSlot := false;                                               // blocks main character movement
       end;
    1: begin                                                                    // Time
         Gam_Stop_Timers_All;                                                     // stops all timers
         Vid_Show_All(false);                                                     // hides all coins, chars, etc.
         Vid_Show_Players_All(true);                                              // displays all slot machines players
         Vid_Show_Slots_All(true);                                                // displays all slot machines

         im_panel_time.Visible := true;                                           // displays "Time"
         im_panel_time_semicolon.Visible := true;                                 // displays clock semicolon

         Timer_Clock.interval := 1;                                               // clock starts ticking
         Timer_Clock.Enabled := true;
       end;
    2, 3: begin                                                                 // Select game G1/G2
         Gam_Stop_Timers_All;                                                     // stops all timers
         Vid_Show_All(false);                                                     // hides all coins, chars, etc.
         Vid_Show_Players_All(true);                                              // displays all slot machines players
         Vid_Show_Slots_All(true);                                                // displays all slot machines

         case iMode of
           2: begin im_panel_game_1.Visible := true; Vid_Show_Panel_Score(iHiScore1, true); end; // displays hiscore
           3: begin im_panel_game_2.Visible := true; Vid_Show_Panel_Score(iHiScore2, true); end; // displays hiscore
         end; // case.of
       end;
    4, 5: begin                                                                 // Game G1/G2
         iScore := 0;                                                             // score set to 0
         iScoreNext := 1000;                                                      // next slot machine game is at 1000 points
         iMisses:=0;                                                              // misses set to 0
         Gam_Clear_Coins_Array;                                                   // clears numeric array of coins

         iLoopGameStart := 1;                                                     // game starts
         Timer_Game_Start.Interval := 1;
         Timer_Game_Start.Enabled := true;
       end;
    6, 7: begin                                                                 // Game over G1/G2
         Timer_Game_Over.Interval := 240000;                                      // four minutes after game is over, goes back into "Time" mode
         Timer_Game_Over.Enabled := true;
       end;
  end; // case..of
end;










{ **************************************************************************** }
{ *                                                                          * }
{ * PROCEDURES: TIMERS                                                       * }
{ *                                                                          * }
{ **************************************************************************** }

procedure TForm1.Timer_ClockTimer(Sender: TObject);
{ transforms current time into "sprites" form, and displays it                 }
{ time semicolon blinks at every 500 milliseconds                              }
  var
    present              : TDateTime;
    hour, min, sec, msec : Word;
    i                    : integer;
begin
  for i := 1 to 4 do                                                            // displays first 4 digits only
    aIm_Panel_Score[i].Visible := true;

  aIm_Panel_Score[5].Visible := false;                                          // hides 5th digit

  Present := now; DecodeTime(present, hour, min, sec, msec);                    // gets system time and decodes it

  if hour > 11 then                                                             // changes time mode from 0/24 to 12 AM/12 PM
    Dec(hour, 12);

  if hour = 0 then                                                              // changes mode from 0/24 to 12 AM/12 PM
    hour := 12;

  if hour > 9 then aIm_Panel_Score[1].Picture := aIm_Panel_Numbers[1, hour div 10 mod 10].Picture else aIm_Panel_Score[1].Picture := nil; // hours: tens
                   aIm_Panel_Score[2].Picture := aIm_Panel_Numbers[2, hour        mod 10].Picture;                                        // hours: units

                   aIm_Panel_Score[3].Picture := aIm_Panel_Numbers[3, min  div 10 mod 10].Picture;                                        // minutes: tens
                   aIm_Panel_Score[4].Picture := aIm_Panel_Numbers[4, min         mod 10].Picture;                                        // minutes: units

  Timer_Clock.Interval := 1000;
end;





procedure TForm1.Timer_Game_StartTimer(Sender: TObject);
{ plays "Start" tune, then sets main character on screen, enables controllers, }
{  and game actually begins                                                    }
begin
  case iLoopGameStart of
    1: begin
         Snd_Play(pfs_start);
         Timer_Game_Start.Interval := 700;
       end;
    2: begin
         Vid_Show_Panel_Score(iScore, true);
         iHeroPos := 1;
         Vid_Show_Hero(iHeroPos, true);
         bControllersGame := true;

         Gam_Set_Game_Difficulty;

         iLoopGame := 1;
         iLoopGameActiveColumn := Random(3) + 1;
         Timer_Game.Enabled := true;

         Timer_Game_Start.Enabled:=false;
       end;
  end; // case..of

  Inc(iLoopGameStart);
end;





procedure TForm1.Timer_Game_OverTimer(Sender: TObject);
{ four minutes after game is over, goes back into "Time" mode                  }
begin
  // game mode is set to "time"
  iMode := 1;                                                                   
  Gam_Set_Mode;

  Timer_Game_Over.Enabled := false;
end;





procedure TForm1.Timer_GameTimer(Sender: TObject);
{ main game action                                                             }
  var
    i, j,
    iOnscreen : integer;
    bGot,
    bMiss     : boolean;
begin
  // various initialization (for later use within this procedure)
  bGot     := false;
  bMiss    := false;

  // checks for misses (all ticks)
  for i := 1 to 3 do
    if (aCoins[i, 3] = 3) and (iHeroPos <> i) then
      bMiss := true;

  // checks for collision hero-coins (all ticks)
  if not bMiss then
    if aCoins[iHeroPos, 3] = 3 then
      begin
        bGot := true;
        Timer_Game_Got.Interval := 1;
      end;

  // no miss has occured, no coin has been got by hero, iLoopGame is odd
  if (not bMiss) and (not bGot) and Odd(iLoopGame) then
    begin
      // moves coins
      for i := 1 to 3 do
        for j := 4 downto 2 do
          begin
            // moves on-screen coins
            if aCoins[i, j - 1] = 3 then
              aCoins[i, j] := aCoins[i, j - 1];

            // manages coins coming out of the slot machines
            if (aCoins[i, j - 1] = 1) or (aCoins[i, j - 1] = 2) then
              Inc(aCoins[i, j - 1])
            else
              // coins in [x, 1]
              aCoins[i, j - 1] := 0;
          end;

      // checks for collision hero-coins (coin just moved)
      if aCoins[iHeroPos, 3] = 3 then
        begin
          bGot := true;
          Timer_Game_Got.Interval := 50;
        end;

      // counts coins on screen
      iOnscreen := 0;

      for i := 1 to 3 do
        for j := 1 to 3 do
          if aCoins[i, j] = 3 then
            Inc(iOnscreen);

      // generates new coins
      if (Random(iCoinsGenRnd) < 5) and (aCoins[iLoopGameActiveColumn, 1] = 0) then aCoins[iLoopGameActiveColumn, 1] := 1;
   // if aCoins[iLoopGameActiveColumn, 2] = 3                                  then aCoins[iLoopGameActiveColumn, 1] := 0;
   // if aCoins[iLoopGameActiveColumn, 3] = 3                                  then aCoins[iLoopGameActiveColumn, 1] := 0;
      if iOnscreen = 0                                                         then aCoins[iLoopGameActiveColumn, 1] := 1;

      // renders coins, players and slot machines to screen
      for i := 1 to 3 do
        begin
          for j := 1 to 4 do
            aIm_Coins[i, j].Visible := aCoins[i, j] >= 3;

          aIm_Players[i, 2].Visible := (aCoins[i, 1] = 0) or (aCoins[i, 1] = 3);
          aIm_Slots[i].Visible := (aCoins[i, 1] = 0) or (aCoins[i, 1] = 3);
        end;

      // plays "coin" in case there's at least one coin on screen
      if iOnscreen > 0 then
        Snd_Play(pfs_coin);

      // loops action (changes active slot machine column)
      Inc(iLoopGameActiveColumn);

      if iLoopGameActiveColumn > 3 then
        iLoopGameActiveColumn := 1;
    end; // (not bMiss) and (not bGot) and Odd(iLoopGame)

  // made a miss?
  if bMiss then
    begin
      Gam_Stop_Timers_All;
      bControllersGame := false;

      iLoopGameMiss := 1;
      Timer_Game_Miss.Interval := 1;
      Timer_Game_Miss.Enabled := true;
    end;

  // got a coin?
  if bGot then
    begin
      Gam_Stop_Timers_All;
      bControllersGame := false;

      iLoopGameGot := 1;
      // Timer_Game_Got.Interval set already before (1 or 20);
      Timer_Game_Got.Enabled := true;
    end;

  // loops action
  Inc(iLoopGame);

  if iLoopGame > 2 then
    iLoopGame := 1;

  // calculates speed and difficulty for next timer tick
  Gam_Set_Game_Difficulty;
end;





procedure TForm1.Timer_Game_GotTimer(Sender: TObject);
{ a coin was got by hero: increases score, eventually goes into the slot       }
{ machine game, or game action reprises                                        }
  var
    i : integer;
begin
  case iLoopGameGot of
    1: begin
         Snd_play(pfs_got);
         Timer_Game_Got.Interval := 80;
       end;
    2: begin
         // increases score by 10
         Inc(iScore, 10);
         Vid_Show_Panel_Score(iScore, true);

         // clears coins in [x,3]
         for i := 1 to 3 do
           begin
             aIm_Coins[i, 3].Visible := false;
             aCoins[i, 3] := 0;
           end;

         // checks score to eventually start the slot machine game
         if iScore >= iScoreNext then
           // slot machine game starts
           begin
             bControllersGame := false;

             iLoopSlot777Start := 1;
             Timer_Slot_777_Start.Interval := 1;
             Timer_Slot_777_Start.Enabled := true;
           end
         else
           begin
             // action reprises
             Timer_Game.Enabled := true;

             bControllersGame := true;

             Timer_Game_Got.Enabled := false;
           end;
       end;
  end; // case..of

  Inc(iLoopGameGot);
end;





procedure TForm1.Timer_Game_MissTimer(Sender: TObject);
{ a miss has occured: increases "miss" counter, eventually goes into game over }
{ mode, or game action reprises                                                }
  var
    i: integer;
begin
  case iLoopGameMiss of
    1: begin
         // blink: on
         for i := 1 to 3 do
           begin
             aCoins[i, 4] := aCoins[i, 3];
             aCoins[i, 3] := 0;
             aIm_Coins[i, 4].Visible := aCoins[i, 4] = 3;
             aIm_Coins[i, 3].Visible := false;
           end;

         Snd_Play(pfs_miss);

         Timer_Game_Miss.Interval := 410;
       end;
    2: // blink: off
       for i := 1 to 3 do aIm_Coins[i, 4].Visible := false;
    3: begin
         // blink: on
         for i := 1 to 3 do
           aIm_Coins[i, 4].Visible := aCoins[i, 4] = 3;

         Snd_Play(pfs_miss);
       end;
    4: // blink: off
       for i := 1 to 3 do aIm_Coins[i, 4].Visible := false;
    5: begin
         // blink: on
         for i := 1 to 3 do
           aIm_Coins[i, 4].Visible := aCoins[i, 4] = 3;

         Snd_Play(pfs_miss);
       end;
    6: begin
         // blink: off
         for i := 1 to 3 do
           begin
             aCoins[i, 4] := aCoins[i, 3];
             aIm_Coins[i, 4].Visible := false;
           end;

           Inc(iMisses);
           Vid_Show_Panel_Miss(iMisses);

         // game reprises or game over
         if iMisses < 3 then
           // game reprises
           begin
             bControllersGame := true;

             Timer_Game.Enabled := true;

             Timer_Game_Miss.Enabled := false;
           end;
         // else game over (goes into case 7 at next timer tick)
       end;
    7: begin
         Snd_Play(pfs_gameover);
         Timer_Game_Miss.Interval := 1000;
       end;
    8: begin
         if (iMode = 4) and (iScore > iHiScore1) then
           begin
             iHiScore1 := iScore;
             iReg.WriteInteger('', 'HiScore1', iHiScore1);
           end;

         if (iMode = 5) and (iScore > iHiScore2) then
           begin
             iHiScore2 := iScore;
             iReg.WriteInteger('', 'HiScore2', iHiScore2);
           end;

         // sets "game over G1" or "game over G2" mode
         Inc(iMode, 2);
         Gam_Set_Mode;

         // starts timer for going to "time" mode in 4 minutes
         Timer_Game_Over.Enabled := true;

         Timer_Game_Miss.Enabled := false;
       end;
  end; // case..of

  Inc(iLoopGameMiss);
end;





procedure TForm1.Timer_Slot_777_StartTimer(Sender: TObject);
{ player scored x000 points: slot machine game begins                          }
{ coins game screen is cleared, and hero appears at the slot machine game on   }
{ the right                                                                    }
  var
    i: integer;
begin
  case iLoopSlot777Start of
    1: Timer_Slot_777_Start.Interval := 1000;
    2: begin
         // displays hero and slot machine digits
         Vid_Show_Hero(iHeroPos, false);
         Vid_Show_Players_All(false);
         Vid_Show_Slots_All(false);
         Vid_Show_Coins_All(false);
         Gam_Clear_Coins_Array;
         i := 1; Vid_Show_Slot_777_Hero(i);

         // sets slot machine number and displays it
         for i := 1 to 3 do
           aSlot777Number[i] := 3;

         Vid_Show_Slot_777_Score(aSlot777Number[1], aSlot777Number[2], aSlot777Number[3], true);

         Timer_Slot_777_Start.Interval := 200;
       end;
    3: begin
         // initializes slot machine game
         iSlot777Bags := 0;
         iSlot777ActiveDigit := 0;

         // hero makes action in 15 seconds or when player press RIGHT arrow
         bControllersGame := false;
         bControllersSlot := true;

         iLoopSlot777Action := 1;
         Timer_Slot_777_Action.Interval := 15000;
         Timer_Slot_777_Action.Enabled := true;

         Timer_Slot_777_Start.Enabled := false;
       end;
  end; // case..of

  Inc(iLoopSlot777Start);
end;





procedure TForm1.Timer_Slot_777_ActionTimer(Sender: TObject);
{ hero pulls the slot machine lever (occurs automatically at every 15 seconds  }
{ in case player doesn't press the right button)                               }
  var
    i: integer;
begin
  case iLoopSlot777Action of
    1: begin
         Snd_Play(pfs_got);
         i := 2; Vid_Show_Slot_777_Hero(i);

         bControllersSlot := false;

         // slot machine starts spinning
         if iSlot777ActiveDigit = 0 then
           begin
             iLoopSlot777Spin := 1;
             Timer_Slot_777_Spin.Interval := 120;
             Timer_Slot_777_Spin.Enabled := true;
           end;

         // sets which digit player's controlling
         Inc(iSlot777ActiveDigit);

         Timer_Slot_777_Action.Interval := 160;
       end;
    2: begin
         i := 1; Vid_Show_Slot_777_Hero(i);

         // reels stopped spinning -> checks the result
         if iSlot777ActiveDigit = 4 then
           begin
             Timer_Slot_777_Spin.Enabled := false;

             if  (aSlot777Number[1] = aSlot777Number[2])
             and (aSlot777Number[1] = aSlot777Number[3]) then
               // "111", "333" or "777" -> bonus 100, 200 or 500 & bag
               begin
                 iLoopSlot777Bonus123 := 1;

                 case aSlot777Number[1] of
                   1: begin Timer_Slot_777_Bonus1.Interval := 1; Timer_Slot_777_Bonus1.Enabled := true; end;
                   2: begin Timer_Slot_777_Bonus2.Interval := 1; Timer_Slot_777_Bonus2.Enabled := true; end;
                   3: begin Timer_Slot_777_Bonus3.Interval := 1; Timer_Slot_777_Bonus3.Enabled := true; end;
                 end; // case..of

                 Timer_Slot_777_Action.enabled := false;
               end
             else
               // other combinations -> misses -> looses 1 bag/returns to coins game
               begin
                 iLoopSlot777Miss := 1;
                 Timer_Slot_777_Miss.Interval := 1;
                 Timer_Slot_777_Miss.Enabled := true;
               end;
           end
         else
           // more reels spinning -> action continues
           begin
             iLoopSlot777Action := 0; // becomes 1 with next Inc()

             bControllersSlot := true;

             Timer_Slot_777_Action.Interval := 15000;
           end;
       end;
  end; // case..of

  Inc(iLoopSlot777Action);
end;





procedure TForm1.Timer_Slot_777_SpinTimer(Sender: TObject);
{ slot machine reels spin: reels are updated and displayed                     }
  var
    i: integer;
begin
  for i := iSlot777ActiveDigit to 3 do
    aSlot777Number[i] := aSlot777Seq[iLoopSlot777Spin];

  Vid_Show_Slot_777_Score(aSlot777Number[1], aSlot777Number[2], aSlot777Number[3], true);

  Inc(iLoopSlot777Spin);

  if iLoopSlot777Spin > 5 then
    iLoopSlot777Spin := 1;
end;





procedure TForm1.Timer_Slot_777_Bonus1Timer(Sender: TObject);
{ player scored 100 points at the slot machine game                            }
begin
  case iLoopSlot777Bonus123 of
    1: begin
         Snd_Play(pfs_got);

         Timer_Slot_777_Bonus1.Interval := 160;
       end;
    2: begin                                                                    // 100 points
         Snd_Play(pfs_got);
         Inc(iScore, 100); Vid_Show_Panel_Score(iScore, true);
       end;
    3: begin                                                                    // action reprises
         iSlot777ActiveDigit := 0;

         bControllersSlot := true;

         iLoopSlot777Action := 1;
         Timer_Slot_777_Action.Interval := 15000;
         Timer_Slot_777_Action.Enabled := true;

         Timer_Slot_777_Bonus1.Enabled := false;
       end;
  end; // case..of

  Inc(iLoopSlot777Bonus123);
end;





procedure TForm1.Timer_Slot_777_Bonus2Timer(Sender: TObject);
{ player scored 200 points at the slot machine game                            }
begin
  case iLoopSlot777Bonus123 of
    1: begin
         Snd_Play(pfs_got);

         Timer_Slot_777_Bonus2.Interval := 160;
       end;
    2: begin                                                                    // 100 points
         Snd_Play(pfs_got);
         Inc(iScore, 100); Vid_Show_Panel_Score(iScore, true);

         Timer_Slot_777_Bonus2.Interval := 320;
       end;
    3: Vid_Show_Slot_777_Score(aSlot777Number[1], aSlot777Number[2], aSlot777Number[3], false);
    4: begin
         Snd_Play(pfs_got);

         Timer_Slot_777_Bonus2.Interval := 160;
       end;
    5: begin                                                                    // 200 points
         Snd_Play(pfs_got);
         Vid_Show_Slot_777_Score(aSlot777Number[1], aSlot777Number[2], aSlot777Number[3], true);
         Inc(iScore, 100); Vid_Show_Panel_Score(iScore, true);
       end;
    6: begin                                                                    // action reprises
         iSlot777ActiveDigit := 0;

         bControllersSlot := true;

         iLoopSlot777Action := 1;
         Timer_Slot_777_Action.Interval := 15000;
         Timer_Slot_777_Action.Enabled := true;

         Timer_Slot_777_Bonus2.Enabled := false;
       end;
  end; // case..of

  Inc(iLoopSlot777Bonus123);
end;





procedure TForm1.Timer_Slot_777_Bonus3Timer(Sender: TObject);
{ player scored 500 points and 1 coins bag at the slot machine game            }
begin
  case iLoopSlot777Bonus123 of
    1: begin
         Snd_Play(pfs_got);

         Timer_Slot_777_Bonus3.Interval := 160;
       end;
    2: begin                                                                    // 100 points
         Snd_Play(pfs_got);
         Inc(iScore, 100); Vid_Show_Panel_Score(iScore, true);

         Timer_Slot_777_Bonus3.Interval := 320;
       end;
    3: Vid_Show_Slot_777_Score(aSlot777Number[1], aSlot777Number[2], aSlot777Number[3], false);
    4: begin
         Snd_Play(pfs_got);

         Timer_Slot_777_Bonus3.Interval := 160;
       end;
    5: begin                                                                    // 200 points
         Snd_Play(pfs_got);
         Vid_Show_Slot_777_Score(aSlot777Number[1], aSlot777Number[2], aSlot777Number[3], true);
         Inc(iScore, 100); Vid_Show_Panel_Score(iScore, true);

         Timer_Slot_777_Bonus3.Interval := 320;
       end;
    6: Vid_Show_Slot_777_Score(aSlot777Number[1], aSlot777Number[2], aSlot777Number[3], false);
    7: begin
         Snd_Play(pfs_got);

         Timer_Slot_777_Bonus3.Interval := 160;
       end;
    8: begin                                                                    // 300 points
         Snd_Play(pfs_got);
         Vid_Show_Slot_777_Score(aSlot777Number[1], aSlot777Number[2], aSlot777Number[3], true);
         Inc(iScore, 100); Vid_Show_Panel_Score(iScore, true);

         Timer_Slot_777_Bonus3.Interval := 320;
       end;
    9: Vid_Show_Slot_777_Score(aSlot777Number[1], aSlot777Number[2], aSlot777Number[3], false);
   10: begin
         Snd_Play(pfs_got);

         Timer_Slot_777_Bonus3.Interval := 160;
       end;
   11: begin                                                                    // 400 points
         Snd_Play(pfs_got);
         Vid_Show_Slot_777_Score(aSlot777Number[1], aSlot777Number[2], aSlot777Number[3], true);
         Inc(iScore, 100); Vid_Show_Panel_Score(iScore, true);

         Timer_Slot_777_Bonus3.Interval := 320;
       end;
   12: Vid_Show_Slot_777_Score(aSlot777Number[1], aSlot777Number[2], aSlot777Number[3], false);
   13: begin
         Snd_Play(pfs_got);

         Timer_Slot_777_Bonus3.Interval := 160;
       end;
   14: begin                                                                    // 500 points
         Snd_Play(pfs_got);
         Vid_Show_Slot_777_Score(aSlot777Number[1], aSlot777Number[2], aSlot777Number[3], true);
         Inc(iScore, 100); Vid_Show_Panel_Score(iScore, true);
       end;
   15: begin                                                                    // bunny girl appears
         im_slot_777_bunny.Visible := true;

         Timer_Slot_777_Bonus3.Interval := 250;
       end;
   16: begin                                                                    // coins bag
         Inc(iSlot777Bags);

         if iSlot777Bags > 3 then
           iSlot777Bags := 3;

         Vid_Show_Slot_777_Bags(iSlot777Bags);

         Timer_Slot_777_Bonus3.Interval := 350;
       end;
   17: begin                                                                    // bunny girl disappears
         im_slot_777_bunny.Visible := false;

         Timer_Slot_777_Bonus3.Interval := 160;
       end;
   18: begin                                                                    // action reprises
         iSlot777ActiveDigit := 0;

         bControllersSlot := true;

         iLoopSlot777Action := 1;
         Timer_Slot_777_Action.Interval := 15000;
         Timer_Slot_777_Action.Enabled := true;

         Timer_Slot_777_Bonus3.Enabled := false;
       end;
  end; // case..of

  Inc(iLoopSlot777Bonus123);
end;





procedure TForm1.Timer_Slot_777_MissTimer(Sender: TObject);
{ player looses 1 bag or returns to the slot machine game                      }
  var
    i: integer;
begin
  case iLoopSlot777Miss of
    1: begin
         Snd_Play(pfs_miss);

         Timer_Slot_777_Miss.Interval := 160;
       end;
    2: begin
         Dec(iSlot777Bags);

         if iSlot777Bags >= 0 then
           // slot machine game continues
           begin
             Vid_Show_Slot_777_Bags(iSlot777Bags);

             iSlot777ActiveDigit := 0;

             bControllersSlot := true;

             iLoopSlot777Action := 1;
             Timer_Slot_777_Action.Interval := 15000;
             Timer_Slot_777_Action.Enabled := true;

             Timer_Slot_777_Miss.Enabled := false;
           end
         else
           Timer_Slot_777_Miss.Interval := 1000;
       end;
    3: begin
         // returns to the coins game
         Vid_Show_Slot_777_Hero_All(false);
         i := 0; Vid_Show_Slot_777_Score(i, i, i, false);

         Vid_Show_Players_All(true);
         Vid_Show_Slots_All(true);

         iHeroPos := 1;
         Vid_Show_Hero(iHeroPos, true);

         Gam_Set_Game_Difficulty;

         // sets score for the next slot machine game
         iScoreNext := ((iScore div 1000) + 1) * 1000;

         bControllersGame := true;

         iLoopGame := 1;
         iLoopGameActiveColumn := Random(3) + 1;
         Timer_Game.Enabled := true;

         Timer_Slot_777_Miss.Enabled := false;
       end;

  end; // case..of

  Inc(iLoopSlot777Miss);
end;










{ **************************************************************************** }
{ *                                                                          * }
{ * PROCEDURES: POPUP MENU MANAGEMENT                                        * }
{ *                                                                          * }
{ **************************************************************************** }

procedure TForm1.pm_0_menuPopup(Sender: TObject);
{ shows the "checked" menuitems if needed. also, hides the game menu if it is  }
{ visible when the popup menu pops up                                          }
begin
{}pm_11_splashscreen.Checked := iReg.ReadBool('', 'SplashScreen', SplashForm.chb_splashscreen.Checked);

{}if bFullscreenMode
    and bGameMenuOpen then
    begin
      bGameMenuOpen := false;
      Form1.Vid_Display_Game_Menu(bGameMenuOpen);
    end;
end;





procedure TForm1.pm_1_aboutClick(Sender: TObject);
{ displays the embedded "About the author..." form                             }
begin
  AboutForm.Show;
end;





procedure TForm1.pm_2_readmeClick(Sender: TObject);
{ opens the "Readme.txt" file                                                  }
begin
  ShellExecute(Handle, 'open', 'Readme.txt', nil, '', SW_SHOWNORMAL);
end;





procedure TForm1.pm_3_whatsnewClick(Sender: TObject);
{ opens the "Whatsnew.txt" file                                                }
begin
  ShellExecute(Handle, 'open', 'Whatsnew.txt', nil, '', SW_SHOWNORMAL);
end;





procedure TForm1.pm_4_manualClick(Sender: TObject);
{ displays the embedded instructions manual                                    }
begin
  ManualForm.Show;
end;





procedure TForm1.pm_6_configClick(Sender: TObject);
{ opens the "Config.ini" file                                                  }
begin
  ShellExecute(Handle, 'open', 'Config.ini', nil, '', SW_SHOWNORMAL);
end;





procedure TForm1.pm_7_keysClick(Sender: TObject);
{ displays the "key settings" form                                             }
begin
  KeysForm.position := poScreenCenter;
  KeysForm.visible := true;
  Form1.Enabled := false;
end;





procedure TForm1.pm_8_hiscoreClick(Sender: TObject);
{ resets high scores to the system registry                                    }
begin
  iHiScore1 := 0; iReg.WriteInteger('', 'HiScore1', iHiScore1);
  iHiScore2 := 0; iReg.WriteInteger('', 'HiScore2', iHiScore2);
  Beep;
end;





{}procedure TForm1.pm_10_fullscreenClick(Sender: TObject);
{ changes from fullscreen to windowed, and vice-versa                          }
begin
  // updates popup menu
  bFullscreenMode := not bFullscreenMode;
  pm_10_fullscreen.Checked := bFullscreenMode;
  bGameMenuOpen := false;

  iReg.WriteBool('', 'FullscreenMode', bFullscreenMode);

  // graphics init
  Top  := - Screen.Height;
  Left := - Screen.Width;
  Gfx_Game_Init;
  Position := poScreenCenter;
end;





procedure TForm1.pm_11_splashscreenClick(Sender: TObject);
{ updates the ticks to the checkbox, the popup menu and the system registry    }
begin
{}pm_11_splashscreen.Checked := not pm_11_splashscreen.Checked;

{}iReg.WriteBool('', 'SplashScreen', pm_11_splashscreen.Checked);
end;





procedure TForm1.pm_14_exitClick(Sender: TObject);
{ exits the game                                                               }
begin
  Application.Terminate;
end;










{ **************************************************************************** }
{ *                                                                          * }
{ * PROCEDURES: GAME MENU MANAGEMENT                                         * }
{ *                                                                          * }
{ **************************************************************************** }

procedure TForm1.btn_game_menu_topClick(Sender: TObject);
{ sets the game menu as visible/hidden, then displays/hides it                 }
begin
  bGameMenuOpen := not bGameMenuOpen;
  Vid_Display_Game_Menu(bGameMenuOpen);
end;





procedure TForm1.la_menu_itemMouseEnter(Sender: TObject);
{ the game menu label bg colour becomes solid                                  }
begin
  if Sender is TLabel then
    TLabel(Sender).Transparent := false;
end;





procedure TForm1.la_menu_itemMouseLeave(Sender: TObject);
{ the game menu label bg colour becomes transparent                            }
begin
  if Sender is TLabel then
    TLabel(Sender).Transparent := true;
end;





procedure TForm1.la_menu_itemMouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
{ hides the game menu, once a label has been pressed                           }
begin
  if Button = mbLeft then
    begin
      bGameMenuOpen := false;
      Vid_Display_Game_Menu(false);
    end;
end;





procedure TForm1.Vid_Display_Game_Menu(b: boolean);
{ displays/hides the game menu, depending on the value of bGameMenuOpen        }
  var
    i: integer;
begin
  case bGameMenuOpen of
    true: begin
        for i := 1 to MENU_ITEMS do
          begin
            aMenuLabels[i] := TLabel.Create(Form1);
            aMenuLabels[i].Parent := Form1;

            aMenuLabels[i].Top := 32 * i;
            aMenuLabels[i].Left := 0;

            aMenuLabels[i].AutoSize := false;
            aMenuLabels[i].Height := 32;
            aMenuLabels[i].Width := 256;
            aMenuLabels[i].Layout := tlCenter;

            aMenuLabels[i].Transparent := true;

            if aMenuItem[i].Caption <> '-' then
              begin
                aMenuLabels[i].Font.Name := 'Arial';
                aMenuLabels[i].Font.Color := clWhite;
                aMenuLabels[i].Font.Height := 16;
                aMenuLabels[i].Caption := '   ' + aMenuItem[i].Caption;

                if aMenuItem[i].Checked then
                  aMenuLabels[i].Caption := aMenuLabels[i].Caption + ' [V]';

                aMenuLabels[i].Color := $00000000;
                aMenuLabels[i].Cursor := crHandPoint;
                aMenuLabels[i].Enabled := aMenuItem[i].Enabled;

                if aMenuLabels[i].Enabled then
                  begin
                    aMenuLabels[i].OnClick      := aMenuItem[i].OnClick;
                    aMenuLabels[i].OnMouseEnter := la_menu_itemMouseEnter;
                    aMenuLabels[i].OnMouseLeave := la_menu_itemMouseLeave;
                    aMenuLabels[i].OnMouseUp    := la_menu_itemMouseUp;
                  end;
              end;
          end;

        btn_game_menu_background.Width := 256;
        btn_game_menu_background.Height := 32 * (MENU_ITEMS + 1)
      end;
    false: begin
        for i := 1 to MENU_ITEMS do
          begin
            aMenuLabels[i].Free;
          end;

        btn_game_menu_background.Height := 32;
        btn_game_menu_background.Width := 36;
      end;
    end; // case..of
end;





initialization
  bStartup := true;





end.
